unit disptest1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtDlgs, ExtCtrls, Spin;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    Button2: TButton;
    Button3: TButton;
    GroupBox1: TGroupBox;
    Image1: TImage;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox1: TCheckBox;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    SpinEdit2: TSpinEdit;
    Label2: TLabel;
    Label3: TLabel;
    SpinEdit3: TSpinEdit;
    RadioGroup1: TRadioGroup;
    Button7: TButton;
    Button8: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
  private
    { Private-Deklarationen }
    msdelay,delz: int64;
    bmp: tbitmap;
    procedure delay(ms: integer);
    procedure WriteData(d: byte);
    procedure WriteCTRL(d: byte);
    procedure PortWR(p:word; data: BYTE);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  bmp:=TBitmap.create;
end;

procedure TForm1.Delay(ms: integer);
var t: TDateTime;
    z: integer;
begin
  t:=now+(5/86400);
  for z:=1 to ms do begin
    delz:=0;
    while (now<t) AND (delz<msdelay) do
      inc(delz);
  end;
end;

procedure TForm1.PortWR(p:word; data: BYTE);
(* Auf Printer-Datenport d ausgeben *)
var bs: word;
begin
  bs:=p;
  asm
    mov dx,bs
    mov al,data
    out dx,al
  end;
end;

procedure TForm1.WriteData(d: byte);
begin
  Delay(1);
  PortWR($378,d);
  portwr($378+2,0); (* C/D = L (Data) *)
  portwr($378+2,2); (* CE *)
  portwr($378+2,3); (* CE+WR *)
  portwr($378+2,2); (* CE *)
  portwr($378+2,0);
end;
procedure TForm1.WriteCtrl(d: byte);
begin
  Delay(1);
  PortWR($378,d);
  portwr($378+2,4); (* C/D = H (ctrl) *)
  portwr($378+2,4+2); (* CE *)
  portwr($378+2,4+3); (* CE+WR *)
  portwr($378+2,4+2); (* CE *)
  portwr($378+2,0);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  WriteData(0);
  WriteData(0);
  WriteCtrl($40); (* Text Home @ 0000h *)
  WriteData(20);
  WriteData(0);
  WriteCtrl($41); (* Text Area 20 *)
  WriteData(0);
  WriteData(1);
  WriteCtrl($42); (* Graph Home @ 0100h *)
  WriteData(20);
  WriteData(0);
  WriteCtrl($43); (* Gr Area 20 *)
  WriteCtrl($80); (* OR Mode *)
  WriteCtrl($9F);
end;

procedure TForm1.Button2Click(Sender: TObject);
var l: array[1..6] of string;
    z: integer;
    s:string;
begin
  if memo1.lines.count>0 then l[1]:=memo1.lines[0] else l[1]:='';
  if memo1.lines.count>1 then l[2]:=memo1.lines[1] else l[2]:='';
  if memo1.lines.count>2 then l[3]:=memo1.lines[2] else l[3]:='';
  if memo1.lines.count>3 then l[4]:=memo1.lines[3] else l[4]:='';
  if memo1.lines.count>4 then l[5]:=memo1.lines[4] else l[5]:='';
  if memo1.lines.count>5 then l[6]:=memo1.lines[5] else l[6]:='';
  s:='';
  for z:=1 to 6 do begin
    while length(l[z])<20 do l[z]:=l[z]+' ';
    s:=s+l[z];
  end;  
  WriteData(0);
  WriteData(0);
  WriteCtrl($24);
  for z:=0 to length(s)-1 do begin
    WriteData(ord(s[z+1])-32);
    WriteCtrl($C0);
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var z: integer;
begin
  WriteData(0);
  WriteData(0);
  WriteCtrl($24);
  for z:=0 to (6*20)-1 do begin
    WriteData(0);
    WriteCtrl($C0);
  end;
  WriteData(0);
  WriteData(1);
  WriteCtrl($24);
  for z:=0 to (48*(120 div 6))-1 do begin
    WriteData(0);
    WriteCtrl($C0);
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var r: Trect;
    z1,z2: single;
begin
  bmp.Loadfromfile(openpicturedialog1.filename);
  z1:=image1.height/bmp.height;
  z2:=image1.width/bmp.width;
  (* Image lschen *)
  image1.Picture.Bitmap.width:=120;
  image1.Picture.Bitmap.height:=48;
  with image1.Picture.Bitmap.canvas do begin
    pen.color:=clWhite;
    brush.color:=clWhite;
    rectangle(0,0,120,48);
  end;
  if z1>z2 then begin
    (* Geladenes bild begrenzt durch breite *)
    with r do begin
      left:=0;
      top:=0;
      right:=120;
      bottom:=round(bmp.height*z2);
    end;
  end else begin
    with r do begin
      left:=0;
      top:=0;
      right:=round(bmp.width*z1);
      bottom:=48;
    end;
  end;
  image1.Picture.Bitmap.canvas.StretchDraw(r,bmp);
end;

procedure TForm1.Button5Click(Sender: TObject);
var x,y,z: integer;
    i: integer;
    pp: single;
    p: TColor;
begin
  randomize;
  WriteData(0);
  WriteData(1);
  WriteCtrl($24);
  for y:=0 to 47 do begin
    for x:=0 to (120 div 6)-1 do begin
      i:=0;
      for z:=0 to 5 do begin
        p:=image1.picture.bitmap.canvas.Pixels[x*6+z,y];
        pp:=0.6*(p AND $FF)+0.30*((p shr 8) AND $FF)+0.1*((p shr 16) AND $FF);
        i:=i shl 1;
        if pp<=random(255) then i:=i or 1;
      end;
      WriteData(i);
      WriteCtrl($C0);
    end;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  bmp.free;
end;

procedure TForm1.FormShow(Sender: TObject);
var t: TDateTime;
begin
  t:=now+(1/86400);
  msdelay:=0;
  delz:=$7FFFFFFFFFFFFFFF;
  while (now<t) AND (msdelay<delz) do
    inc(msdelay);
  msdelay:=msdelay div 1000;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  openpicturedialog1.execute;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
var b: byte;
begin
  b:=$90;
  if checkbox1.checked then b:=b or 1;
  if checkbox2.checked then b:=b or 2;
  if checkbox3.checked then b:=b or 8;
  if checkbox4.checked then b:=b or 4;
  WriteCtrl(b);
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  CheckBox1Click(Sender);
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  CheckBox1Click(Sender);
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  CheckBox1Click(Sender);
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  WriteData(SpinEdit1.Value-1);
  WriteData(SpinEdit2.Value-1);
  WriteCtrl($21);
end;

procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
  SpinEdit1Change(Sender);
end;

procedure TForm1.SpinEdit3Change(Sender: TObject);
begin
  WriteCtrl($A0+SpinEdit3.value-1);
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  case RadioGroup1.itemindex of
    0: WriteCtrl($80); (* OR Mode *)
    1: WriteCtrl($81);
    2: WriteCtrl($83);
  end;  
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  image1.Picture.Bitmap.width:=120;
  image1.Picture.Bitmap.height:=48;
  with image1.Picture.Bitmap.canvas do begin
    pen.color:=clblack;
    brush.color:=clblack;
    rectangle(0,0,120,48);
  end;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  image1.Picture.Bitmap.width:=120;
  image1.Picture.Bitmap.height:=48;
  with image1.Picture.Bitmap.canvas do begin
    pen.color:=clWhite;
    brush.color:=clWhite;
    rectangle(0,0,120,48);
  end;
end;

end.
